-- the haunted pantry
add_choice_text("Trespasser", { -- choice adventure number: 117
	["Tackle him"] = { text = "Fight Knob Goblin Assistant Chef", good_choice = true },
	["Challenge him to a magical duel"] = "Gain 4-8 mysticality",
	["Wait and see what happens"] = "Get 1-5 starting area items",
})

add_choice_text("The Singing Tree", { -- choice adventure number: 116
	["&quot;Sing a sad song&quot;"] = "Gain 4-5 mysticality",
	["&quot;Sing a happy song&quot;"] = "Gain 4-5 moxie",
	["&quot;Sing whatever you want&quot;"] = "Get 7-8 mysticality or a whiskey and soda",
	["&quot;No singing, thanks.&quot;"] = { leave_noturn = true, good_choice = true },
})

add_choice_text("Oh No, Hobo", { -- choice adventure number: 115
	["Give him a beating"] = { text = "Fight a drunken half-orc hobo", good_choice = true },
	["Give him some Meat"] = "Get Good Karma or nothing",
	["Give him the business"] = "Get 5-10 meat and 3-4 mysticality and 3-4 moxie",
})

add_choice_text("The Baker's Dilemma", { -- choice adventure number: 114
	["&quot;I'll see what I can do.&quot;"] = "Get unlit birthday cake",
	["&quot;Sorry, I'm busy right now.&quot;"] = { leave_noturn = true, good_choice = true },
	["&quot;Hey, what's that over there?&quot;"] = { text = "Gain 4-5 moxie", getmeatmin = 15, getmeatmax = 20 },
})

-- wine cellar

add_processor("/desc_item.php", function()
	local glyph = text:match([[title="(Arcane Glyph #[0-9]+)"]])
	if glyph then
		tbl = ascension["zone.manor.glyphs"] or {}
		name = text:match("<b>(dusty bottle of [A-Za-z ]+)</b>")
		print(name .. " -> " .. glyph)
		tbl[glyph] = name
		ascension["zone.manor.glyphs"] = tbl
	end
end)

add_processor("/manor3.php", function()
	if text:match("Your eyes are drawn to a pattern of odd glyphs") then
		tbl = ascension["zone.manor.glyphs"]
		if not tbl then return end
		wines_needed = {}
		for x in text:gmatch([[title="(Arcane Glyph #[0-9]+)"]]) do
			print("glyph:"..x.." -> "..tostring(tbl[x]))
			table.insert(wines_needed, tbl[x])
		end
		ascension["zone.manor.wines needed"] = wines_needed
	end
end)

add_processor("item drop", function ()
	if adventure_zone then
		if item_name:match("^dusty bottle of ") then
-- 			print("bottle drop", adventure_zone, item_image, item_name, text)
			tbl = ascension["zone.manor.wine cellar bottles"] or {}
			if not tbl[adventure_zone] then
				tbl[adventure_zone] = {}
			end
			tbl[adventure_zone][item_name] = true
			ascension["zone.manor.wine cellar bottles"] = tbl
		end
	end
end)

-- function get_expected_wine_cellar_ticks_needed(known_tbl, wines_missing)
-- 	local function f(real_ptbl, observed_tbl, still_need)
-- 		for _, z in ipairs { 178,179, 180, 181 } do
-- 			local p_nochange = 0
-- 			
-- 		end
-- 	end
-- 	local init_permutations, _ = get_wine_cellar_permutations_and_quadrants(known_tbl)
-- 	for ptbl in tblvalues(init_permutations) do
-- 		f(ptbl, known_tbl, wines_missing)
-- 	end
-- end

add_printer("/manor3.php", function ()
	if not ascension["zone.manor.wines needed"] then return end
	local tbl = ascension["zone.manor.wine cellar bottles"] or {}

	local wines, valid_permutations = get_wine_cellar_data(tbl)

-- 	for z, wtbl in pairs(wines) do
-- 		print("wine", z, table_to_str(wtbl))
-- 	end

	local wines_needed_list = ascension["zone.manor.wines needed"] or {}
-- 	local wines_missing = {}
-- 	for wine in tblvalues(wines_needed_list) do
-- 		if not have(wine) then
-- 			table.insert(wines_missing, wine)
-- 		end
-- 	end
-- 	get_expected_wine_cellar_ticks_needed(tbl, wines_missing)
	
	local wines_needed_status = {}
	if not text:match("Summoning Chamber") then
		for wine in tblvalues(wines_needed_list) do
			if have(wine) then
				wines_needed_status[wine] = "have"
			else
				wines_needed_status[wine] = "need"
			end
		end
	end
	
	function get_zone_wines(z)
		local wine_names = {}
		for wine, count in pairs(wines[z]) do
			table.insert(wine_names, wine)
		end
		table.sort(wine_names)
		local retstr = ""
		for _, wine in ipairs(wine_names) do
			if wines[z][wine] == valid_permutations then
				starttag, winestr, endtag = "<td>", wine:gsub("dusty bottle of ", ""), "</td>"
			else
				starttag, winestr, endtag = [[<td style="font-size: 66%%;">]], wine:gsub("dusty bottle of ", "") .. ": " .. string.format("%.1f%%%%", 100 * wines[z][wine] / valid_permutations), "</td>"
			end
			if wines_needed_status[wine] == "need" then
				winestr = [[<span style="color: darkorange">]] .. winestr .. "</span>"
			elseif wines_needed_status[wine] == "have" then
				winestr = [[<span style="color: green">]] .. winestr .. "</span>"
			else
				winestr = [[<span style="color: gray">]] .. winestr .. "</span>"
			end
			retstr = retstr .. "<tr>" .. starttag .. winestr .. endtag .. "</tr>"
		end
		return [[<table style="height: 100px; vertical-align: middle;"><tr><td><table style="text-align: center;">]] .. retstr .. [[</table></td></tr></table>]]
	end
	text = text:gsub([[(<td width=100 height=100>)(<a href="adventure.php%?snarfblat=178">.-)(</td>)]], [[%1<div style="position: relative;"><div style="position: absolute; right: 100px; width: 100px; height: 100px;">]] .. get_zone_wines(178) .. [[</div>%2</div>%3]])
	text = text:gsub([[(<td width=100 height=100>)(<a href="adventure.php%?snarfblat=179">.-)(</td>)]], [[%1<div style="position: relative;"><div style="position: absolute; left: 100px; width: 100px; height: 100px;">]] .. get_zone_wines(179) .. [[</div>%2</div>%3]])
	text = text:gsub([[(<td width=100 height=100>)(<a href="adventure.php%?snarfblat=180">.-)(</td>)]], [[%1<div style="position: relative;"><div style="position: absolute; right: 100px; width: 100px; height: 100px;">]] .. get_zone_wines(180) .. [[</div>%2</div>%3]])
	text = text:gsub([[(<td width=100 height=100>)(<a href="adventure.php%?snarfblat=181">.-)(</td>)]], [[%1<div style="position: relative;"><div style="position: absolute; left: 100px; width: 100px; height: 100px;">]] .. get_zone_wines(181) .. [[</div>%2</div>%3]])
end)

-- gallery stuff

add_processor("/choice.php", function()
	if text:contains("one of Stephen's pet alligators swallowed the gallery's key") then
		ascension["zone.conservatory.gallery key"] = "unlocked"
	end
end)

add_printer("/manor.php", function()
	if not have("Spookyraven gallery key") then
		if ascension["zone.conservatory.gallery key"] == "unlocked" then
			local galkeytext = [[<table style="height: 100px; vertical-align: middle;"><tr><td><span style="color: green">Gallery key available</span></td></tr></table>]]
			text = text:gsub([[(<td width=100 height=100>)(<a href="adventure.php%?snarfblat=103">.-)(</td>)]], [[%1<div style="position: relative;"><div style="position: absolute; left: 105px; width: 100px; height: 100px;">]] .. galkeytext .. [[</div>%2</div>%3]])
		end
	end
end)

--~ billiards room

add_choice_text("Minnesota Incorporeals", function()
	if have("Spookyraven library key") or not buff("Chalky Hand") then
		return {
			["Break"] = "Gain moxie",
			["Let the ghost break"] = "Gain muscle or mysticality",
			["Run away"] = { leave_noturn = true },
		}
	else
		return {
			["Break"] = "Gain moxie",
			["Let the ghost break"] = "<b>Get library key</b> or gain muscle or mysticality",
			["Run away"] = { leave_noturn = true },
		}
	end
end)

add_choice_text("Broken", function()
	if have("Spookyraven library key") or not buff("Chalky Hand") then
		return {
			["Go for a solid"] = "Gain mysticality",
			["Go for a stripe"] = "Gain muscle",
			["Go for a walk"] = { leave_noturn = true },
		}
	else
		return {
			["Go for a solid"] = "<b>Get library key</b> or gain mysticality",
			["Go for a stripe"] = "Gain muscle",
			["Go for a walk"] = { leave_noturn = true },
		}
	end
end)

add_choice_text("A Hustle Here, a Hustle There", function()
	if have("Spookyraven library key") then
		return {
			["Go for the 8-ball"] = { text = "Already have library key", disabled = true },
			["Play defensively"] = "Gain mysticality",
			["Chicken out"] = { leave_noturn = true },
		}
	elseif buff("Chalky Hand") then
		return {
			["Go for the 8-ball"] = { getitem = "Spookyraven library key", good_choice = true },
			["Play defensively"] = "Gain mysticality",
			["Chicken out"] = { leave_noturn = true },
		}
	else
		return {
			["Go for the 8-ball"] = { text = "Get library key (requires using hand chalk)", disabled = true },
			["Play defensively"] = "Gain mysticality",
			["Chicken out"] = { leave_noturn = true },
		}
	end
end)

add_ascension_zone_check(105, function()
	if have("pool cue") and not buff("Chalky Hand") and not have("Spookyraven library key") and have("handful of hand chalk") then
		return "You need to use hand chalk to get the library key."
	end
end)


-- library

add_choice_text("Take a Look, it's in a Book!", {
	["Read &quot;The Rise of the House of Spookyraven&quot;"] = { text = "Read stories...", disabled = true },
	["Read &quot;The Better Haunted Homes and Conservatories Cookbook&quot;"] = "Get a random cooking recipe",
	["Read &quot;Ancient Forbidden Unspeakable Evil, a Love Story&quot;"] = "Gain myst or mox or myst spookyraven skill...",
	["Reading is for losers.  I'm outta here."] = { leave_noturn = true },

	["Read &quot;The Fall of the House of Spookyraven&quot;"] = "Unlock tombstone adventure...",
	["Read &quot;To Serve Man... Delicious Cocktails&quot;"] = "Get a random mixing recipe",
	["Read &quot;Ancient Forbidden Unspeakable Yoga, a Beginner's Guide&quot;"] = "Gain muscle and take damage",
})

add_choice_text("Naughty, Naughty...", {
	["Read Chapter 1:  Tuesdays with Abhorrent Fiends"] = "Gain myst",
	["Read Chapter 2:  The Nether Planes on 350 Meat a Day"] = "Gain mox",
	["Read Chapter 3:  Twisted, Curdled, Corrupt Energy and You"] = "Gain myst spookyraven skill or take damage",
})

add_choice_text("History is Fun!", { -- choice adventure number: 87
	["Read Chapter 1: Things Get Weirder"] = { disabled = true },
	["Read Chapter 2: Stephen and Elizabeth"] = { text = "Unlock key adventure in the conservatory" },
	["Read Chapter 3:  Last Days"] = { disabled = true },
})

-- bathroom

add_choice_text("Having a Medicine Ball", { -- choice adventure number: 105
	["Gaze deeply into the mirror"] = { text = "Gain mysticality", good_choice = true },
	["Open it and see what's inside"] = { text = "Get item or leave" },
	["Say &quot;Guy made of bees.&quot;"] = { text = "Repeat 5 times to fight The Guy Made Of Bees" },
})

add_choice_text("Don't Hold a Grudge", { -- choice adventure number: 402
	["Armwrestle it"] = { text = "Gain muscle" },
	["Declare a thumb war"] = { text = "Gain mysticality", good_choice = true },
	["Shake it"] = { text = "Gain moxie" },
})

-- bedroom

add_choice_text("One Nightstand", function ()
	if text:contains("fine mahogany nightstand") then
		if have_equipped("Lord Spookyraven's spectacles") then
			return {
				["Check the top drawer"] = "Get coin purse",
				["Check the bottom drawer"] = "Fight nightstand",
				["Look under the nightstand"] = "Get spookyraven skill item",
			}
		else
			return {
				["Check the top drawer"] = "Get coin purse",
				["Check the bottom drawer"] = "Fight nightstand",
				["Look under the nightstand"] = { text = "If wearing spectacles, get spookyraven skill item", disabled = true },
			}
		end
	elseif text:contains("ornately carved nightstand") then
		if have("Lord Spookyraven's spectacles") then
			return {
				["Open the top drawer"] = "Gain meat",
				["Open the bottom drawer"] = "Gain mysticality",
				["Look behind the nightstand"] = { getitem = "Lord Spookyraven's spectacles", disabled = true },
			}
		else
			return {
				["Open the top drawer"] = "Gain meat",
				["Open the bottom drawer"] = "Gain mysticality",
				["Look behind the nightstand"] = { getitem = "Lord Spookyraven's spectacles", good_choice = true },
			}
		end
	elseif text:contains("simple white nightstand") then
		return {
			["Look in the top drawer"] = "Get wallet",
			["Look in the bottom drawer"] = "Gain muscle",
			["Kick it and see what happens"] = "Fight nightstand",
		}
	elseif text:contains("simple wooden nightstand") then
		if have("Spookyraven ballroom key") then
			return {
				["Check the top drawer"] = "Gain moxie",
				["Check the bottom drawer"] = { getitem = "Spookyraven ballroom key", disabled = true },
				["Investigate the jewelry"] = "Fight mistress",
			}
		elseif ascension["zone.manor.unlocked ballroom key"] == "yes" then
			return {
				["Check the top drawer"] = "Gain moxie",
				["Check the bottom drawer"] = { getitem = "Spookyraven ballroom key", good_choice = true },
				["Investigate the jewelry"] = "Fight mistress",
			}
		else
			return {
				["Check the top drawer"] = { text = "Gain moxie and unlock ballroom key", good_choice = true },
				["Check the bottom drawer"] = "When unlocked, get ballroom key",
				["Investigate the jewelry"] = "Fight mistress",
			}
		end
	end
end)

add_printer("/manor2.php", function()
	if not have("Spookyraven ballroom key") then
		if ascension["zone.manor.unlocked ballroom key"] == "yes" then
			local brkeytext = [[<table style="height: 100px; vertical-align: middle;"><tr><td><span style="color: green">Ballroom key available</span></td></tr></table>]]
			text = text:gsub([[(<td width=100 height=100>)(<A href="adventure.php%?snarfblat=108">.-)(</td>)]], [[%1<div style="position: relative;"><div style="position: absolute; left: -105px; width: 100px; height: 100px;">]] .. brkeytext .. [[</div>%2</div>%3]], 1)
		end
	end
end)

-- ballroom

add_choice_text("Strung-Up Quartet", {
	["&quot;Play 'Provare Compasione Per El Sciocco'&quot;"] = "Set song to +5 ML",
	["&quot;Play 'Sono Un Amanten Non Un Combattente'&quot;"] = "Set song to +5% non-combats",
	["&quot;Play 'Le Mie Cose Favorite'&quot;"] = "Set song to +5% items",
	["&quot;Play nothing, please.&quot;"] = "Disable song (does not cost an adventure)",
})

add_choice_text("Curtains", {
	["Investigate the organ"] = "Fight an organist or get moxie spookyraven skill",
	["Watch the dancers"] = "Gain moxie",
	["Pay no attention to the stuff in front of the curtain"] = { leave_noturn = true },
})

add_itemdrop_counter("dance card", function(c)
	if c == 1 then
		return "(" .. c .. " card in inventory.)"
	else
		return "(" .. c .. " cards in inventory.)"
	end
end)

add_processor("/inv_use.php", function ()
	if text:contains("You pencil your name in on the last line of the dance card, and it evaporates in a puff of ectoplasm.") then
		dance_turn = turnsthisrun() + 3
		ascension["dance card turn"] = dance_turn
	end
end)

add_printer("/charpane.php", function ()
	local dance_card_turn = ascension["dance card turn"]
	if dance_card_turn then
		local turnsleft = dance_card_turn - turnsthisrun()
		if turnsleft >= 0 then
			color = nil
			link = nil
			if turnsleft == 0 then
				color = "green"
				link = "adventure.php?snarfblat=109"
			end
			print_charpane_value({ name = "Dance card", value = turnsleft, color = color, link = link })
		end
	end
end)

add_always_warning("/adventure.php", function()
	if tonumber(ascension["dance card turn"]) == turnsthisrun() and have("ten-leaf clover") then
		return "Your ten-leaf clover will override the ballroom dance.", "dance card-semirare"
	end
end)

add_always_warning("/adventure.php", function()
	if tonumber(ascension["dance card turn"]) == turnsthisrun() then
		if tonumber(params.snarfblat) ~= 109 then
			return "Next turn is a possible dance in the ballroom", "dance card-wrong zone"
		end
	end
end)

-- gallery
add_choice_text("Out in the Garden", { -- choice adventure number: 89
	["The first knight"] = "Get SC skill / fight knight (+spooky damage)",
	["The second knight"] = "Get TT skill / <b>fight knight (+ML)</b>",
	["The two maidens"] = "Get Dreams and Lights or lose HP",
})

-- louvre
add_processor("/choice.php", function ()
	if adventure_title == "Louvre It or Leave It " then
-- 		print("louvre", choice_adventure_number, table_to_str(params))
		whichchoice = params.whichchoice
		option = params.option
		if whichchoice == "" then whichchoice = nil else whichchoice = tonumber(whichchoice) end
		if option == "" then option = nil else option = tonumber(option) end
		if choice_adventure_number and whichchoice and option then
			if choice_adventure_number ~= 91 then -- TODO: Hmm, bit hardcoded, check for some text instead?
				ascension["louvre.map.adventure." .. whichchoice .. ".choice." .. option] = "choice " .. choice_adventure_number
-- 				print("setting", whichchoice, option, "choice", choice_adventure_number)
-- 			else
-- 				print("louvre debug", choice_adventure_number, text)
			end
		end
		ascension["louvre.lastadventure"] = choice_adventure_number
	else
-- 		print("not-louvre", choice_adventure_number, table_to_str(params), "|" .. tostring(adventure_title) .. "|")
		lastlouvre = ascension["louvre.lastadventure"]
-- 		print("lastlouvre", lastlouvre, type(lastlouvre))
		if lastlouvre then
			whichchoice = params.whichchoice
			option = params.option
			if whichchoice == "" then whichchoice = nil else whichchoice = tonumber(whichchoice) end
			if option == "" then option = nil else option = tonumber(option) end
-- 			print("which, opt", whichchoice, option, type(whichchoice))
			if whichchoice and option and tostring(lastlouvre) == tostring(whichchoice) then
-- 				print("louvre-result", choice_adventure_number, table_to_str(params), adventure_title)
				results = {}
				results["&quot;Hey, Wayne,&quot; he replies."] = "Gain muscle"
				results["the scene fills you with new insight as to the nature of the universe"] = "Gain mysticality"
				results["only playing for dog biscuits"] = "Gain moxie"
				results["Nothing better than a picnic on a bright summer day such as this"] = "Get Manetwich"
				results["a burly bearded guy in a wifebeater and straw hat gives you a funny look"] = "Get bottle of Pinot Renoir"
				results["bed and inspect the awkwardly slanted nightstand"] = "Get bottle of Vangoghbitussin"
				for a, b in pairs(results) do
					if text:contains(a) then
						ascension["louvre.map.adventure." .. whichchoice .. ".choice." .. option] = "result " .. b
-- 						print("setting result", whichchoice, option, "result", b)
					end
				end
			end
		end
	end
end)

add_automation_script("automate-louvre", function ()
	text, url = "Trying to automate louvre...", path
	for i = 1, 100 do
		local p = params["choice" .. i]
		if p then
			local whichchoice, option = p:match("([0-9]+)%-([0-9]+)")
--			print(params["choice" .. i], whichchoice, option)
			text, url = post_page("/choice.php", { pwd = params.pwd, whichchoice = whichchoice, option = option })
		else
			break
		end
	end
	return text, url
end)

-- TODO: redo how louvre is tracked/displayed

add_choice_text("Louvre It or Leave It ", function()
	if not choice_adventure_number then return end
	found = {}
	reached = {}
	available = {}
	available[choice_adventure_number] = -1000
	for i = 1, 1000 do
		old_available = available
		available = {}
		found_any = false
		for choicenum, source in pairs(old_available) do
			found_any = true
			reached[choicenum] = source
			for initialc = 1, 3 do
				initialto = ascension["louvre.map.adventure." .. choicenum .. ".choice." .. initialc]
				if initialto then
					tochoice = initialto:match("^choice ([0-9]+)$")
					toresult = initialto:match("^result (.+)$")
					if tochoice then
						if not reached[tochoice] and not available[tochoice] then
							available[tochoice] = { whichchoice = choicenum, option = initialc }
						end
					end
					if toresult then
						if not found[toresult] then
							found[toresult] = { whichchoice = choicenum, option = initialc }
						end
					end
				end
			end
		end
		if not found_any then
			break
		end
	end
	choice_tbl = {}
	for result, source in pairs(found) do
		function trace(source, tbl)
			if source == -1000 then
				return {}
			else
				tbl = trace(reached[source.whichchoice])
				table.insert(tbl, source)
				return tbl
			end
		end
		local t = trace(source)
		choice_string = text:match([[<input type=hidden name=whichchoice value=]] .. choice_adventure_number .. [[><input type=hidden name=option value=]] .. t[1].option .. [[><input class=button type=submit value="([^"]+)">]])
		if not choice_tbl[choice_string] then
			choice_tbl[choice_string] = {}
		end
		local tparams = {}
		tparams.pwd = text:match([[<input type=hidden name=pwd value='([0-9a-f]+)'>]])
		for a, b in pairs(t) do
			tparams[string.format("choice%d", a)] = string.format("%d-%d", b.whichchoice, b.option)
		end
		local pwd = text:match([[<input type=hidden name=pwd value='([0-9a-f]+)'>]])
		if result == "Gain muscle" then
			result = "<b>" .. result .. "</b>"
		end
		table.insert(choice_tbl[choice_string], [[<a href="]]..louvre_href(tparams)..[[">]] .. result .. [[</a>]])
	end
	for a, b in pairs(choice_tbl) do
		choice_tbl[a] = table.concat(b, ", ")
	end
	return choice_tbl
end)

--~ 	add_choice_text("Louvre It or Leave It ", function()
--~ 		if not choice_adventure_number then return end
--~ 		choice_data = {}
--~ 		for initialc = 1, 3 do
--~ 			initialto = get_ascension_state("louvre.map.adventure." .. tostring(choice_adventure_number) .. ".choice." .. tostring(initialc))
--~ 			result_desc = ""
--~ 			if initialto ~= "" then
--~ 	--~ 		print("initial for", initialc, initialto)
--~ 				tochoice = string.match(initialto, "^choice ([0-9]+)$")
--~ 				toresult = string.match(initialto, "^result (.+)$")
--~ 				if tochoice then
--~ 					can_hit = {}
--~ 					explored = {}
--~ 					results = {}
--~ 					can_hit[tochoice] = true
--~ 					for i = 1, 1000 do -- be absolutely certain to terminate, even if bugged
--~ 						for x, _ in pairs(can_hit) do
--~ 							if not explored[x] then
--~ 	--~ 						print("exploring", x)
--~ 								explored[x] = true
--~ 								for c = 1, 3 do
--~ 									to = get_ascension_state("louvre.map.adventure." .. x .. ".choice." .. tostring(c))
--~ 									if to ~= "" then
--~ 	--~ 								print("hitting", to)
--~ 										tochoice = string.match(to, "^choice ([0-9]+)$")
--~ 										toresult = string.match(to, "^result (.+)$")
--~ 										if tochoice then
--~ 											can_hit[tochoice] = true
--~ 										elseif toresult then
--~ 											results[toresult] = true
--~ 										end
--~ 									end
--~ 								end
--~ 							end
--~ 						end
--~ 					end
--~ 					found_results = {}
--~ 					for a, b in pairs(results) do
--~ 						short_desc = string.match(a, "^[A-Za-z]+ (.+)$")
--~ 						if not short_desc then
--~ 							short_desc = string.match(a, "^<b>[A-Za-z]+ (.+)</b>$")
--~ 							if short_desc then short_desc = "<b>" .. short_desc .. "</b>" end
--~ 						end
--~ 						table.insert(found_results, short_desc)
--~ 					end
--~ 					table.sort(found_results)
--~ 					found_str = ""
--~ 					for x in tblvalues(found_results) do
--~ 						if found_str ~= "" then found_str = found_str .. ", " end
--~ 						found_str = found_str .. x
--~ 					end
--~ 					if found_str == "" then
--~ 						result_desc = "Explore maze"
--~ 					else
--~ 						result_desc = "Explore maze (found: " .. found_str .. ")"
--~ 					end
--~ 				elseif toresult then
--~ 					result_desc = toresult
--~ 				end
--~ 			end
--~ 			choice_string = string.match(text, [[<input type=hidden name=whichchoice value=]] .. tostring(choice_adventure_number) .. [[><input type=hidden name=option value=]] .. tostring(initialc) .. [[><input class=button type=submit value="([^"]+)">]])
--~ 			if choice_string and result_desc ~= "" then
--~ 				choice_data[choice_string] = result_desc
--~ 			end
--~ 		end
--~ 		return choice_data
--~ 	end)

local wines_href = add_automation_script("automate-pour-manor-wines", function ()
--	posting page /manor3.php params: Just [("action","pourwine"),("whichwine","2271")]
	local wines_needed_list = ascension["zone.manor.wines needed"] or {}
	local got = 0
	for wine in tblvalues(wines_needed_list) do
		if have(wine) then
			got = got + 1
		end
	end

	if got == 3 then
		for wine in tblvalues(wines_needed_list) do
			text, url = post_page("/manor3.php", { action = "pourwine", whichwine = get_itemid(wine) })
		end
	end
	return text, url
end)

add_printer("/manor3.php", function()
	if text:match("How curious.") then
		tbl = ascension["zone.manor.wines needed"]
		if not tbl then return end
		prints = {}
		table.insert(prints, "<ol>")
		for _, x in ipairs(tbl) do
			table.insert(prints, "<li>" .. x .. "</li>")
		end
		table.insert(prints, "</ol>")

		local wines_needed_list = ascension["zone.manor.wines needed"] or {}
		local count = 0
		local got = 0
		for wine in tblvalues(wines_needed_list) do
			count = count + 1
			if have(wine) then
				got = got + 1
			end
		end

		if count == 3 then
			if got == 3 then
				table.insert(prints, [[<a href="]]..wines_href { pwd = session.pwd }..[[" style="color:green;">{Pour all 3}</a>]])
			else
				table.insert(prints, [[<span style="color:gray;">{Pour all 3}</span>]])
			end
		end

		text = text:gsub("How curious.", function(x) return x .. "<br>" .. table.concat(prints) end)
	end
end)


add_processor("/choice.php", function()
	if text:contains("As you open the top drawer, you hear a clinking sound from deeper inside the nightstand.") or text:contains("In the top drawer of the nightstand, you find a paperback of the") then
		ascension["zone.manor.unlocked ballroom key"] = "yes"
	end
end)

add_processor("/choice.php", function()
	-- TODO: add the others
	if text:contains("The quartet begins to play a mellow, relaxing tune.") then
		ascension["zone.manor.quartet song"] = "Sono Un Amante Non Un Combattente"
	end
	if text:contains("&quot;Just keep playing what you've been playing.&quot;") then
		if tonumber(params.option) == 2 then
			ascension["zone.manor.quartet song"] = "Sono Un Amante Non Un Combattente"
		end
	end
end)
